// Sample file provided by Nicolas Bonneel (http://www.bonneel.com)
// TreeGenerator sample (http://www.treegenerator.com)

#include "ExampleApplication.h"

// trasnformation matrix from Ogre sourcecode
const Matrix4 PROJECTIONCLIPSPACE2DTOIMAGESPACE_PERSPECTIVE(
	0.5,    0,    0,  0.5, 
	0,   -0.5,    0,  0.5, 
	0,      0,  0.5,  0.5,
	0,      0,    0,    1);



class OgreTreeGeneratorFrameListener : public ExampleFrameListener
{
protected:
	SceneManager* mSceneMgr;
	std::vector<Pass*> *mShadowReceivers;

public:
	OgreTreeGeneratorFrameListener(RenderWindow* win, Camera* cam, SceneManager* mgr, std::vector<Pass*> *shadowReceivers)
		: ExampleFrameListener(win, cam)
	{
		mSceneMgr = mgr;
		mShadowReceivers = shadowReceivers;
	}

	bool frameStarted(const FrameEvent& evt)
	{
		if(!ExampleFrameListener::frameStarted(evt))
			return false;

		// set the projection matrix by hand to all shadow receivers
		Camera* lightCamera = mSceneMgr->getCamera("lightCamera");
		Matrix4 projector = PROJECTIONCLIPSPACE2DTOIMAGESPACE_PERSPECTIVE*lightCamera->getProjectionMatrixWithRSDepth() 
			*lightCamera->getViewMatrix();
		for (int i=0; i<mShadowReceivers->size(); i++)
			(*mShadowReceivers)[i]->getVertexProgramParameters()->setNamedConstant("p_TextureViewProjection" ,projector);

		return true;

	}

};

